import timeit

setup_code = '''
def binary_search(array, search_value):
    lower_bound = 0
    upper_bound = len(array) - 1

    while lower_bound <= upper_bound:

        midpoint = (upper_bound + lower_bound) // 2
        value_at_midpoint = array[midpoint]

        if search_value == value_at_midpoint:
            return midpoint
        elif search_value < value_at_midpoint:
            upper_bound = midpoint - 1
        elif search_value > value_at_midpoint:
            lower_bound = midpoint + 1

    return None

array = []
for i in range(1_000_000):
    array.append(i)
'''

test_code = '''
binary_search(array, 89124)
'''

print(timeit.repeat(stmt=test_code, setup=setup_code, repeat=5, number=1))
