import random


class TreeNode:
    def __init__(self, value, left=None, right=None):
        self.value = value
        self.left_child = left
        self.right_child = right


def insert(value, node):
    if value < node.value:

        if not node.left_child:
            node.left_child = TreeNode(value)
        else:
            insert(value, node.left_child)

    elif value > node.value:

        if not node.right_child:
            node.right_child = TreeNode(value)
        else:
            insert(value, node.right_child)


def tree_size(node):
    level_size = 1
    total_size = 1

    current_node = node.left_child
    while current_node:
        level_size *= 2
        total_size += level_size
        current_node = current_node.left_child

    return total_size


def sample(node):
    subtree_size = tree_size(node)
    current_node = node

    while current_node:
        roll = random.randint(1, subtree_size)
        if roll == 1:
            return current_node.value

        subtree_size //= 2

        roll = random.randint(1, 2)
        if roll == 1:
            current_node = current_node.left_child
        else:
            current_node = current_node.right_child
