import doubly_linked_list
import time


class LruCache:

    def __init__(self):
        self.hash_table = {}
        self.linked_list = doubly_linked_list.DoublyLinkedList()
        self.max_size = 4

    def read_from_cache(self, key):
        # Cache hit:
        if key in self.hash_table:
            node = self.hash_table.get(key)
            self.linked_list.move_to_head(node)
        # Cache miss:
        else:
            # If cache is full:
            if len(self.hash_table) == self.max_size:
                # Evict LRU data:
                evicted_data = self.linked_list.pop_tail().data[0]
                del self.hash_table[evicted_data]

            # Fetch new data and insert at the front of the cache:
            data = search_web_for(key)
            new_node = self.linked_list.insert_head(data)
            self.hash_table[key] = new_node

def search_web_for(product):
    # Mock data:
    data_from_web = [product, 1]
    # Mimic time it takes to search web:
    time.sleep(0.25)

    return data_from_web


