import treap_node
import treap
import random

def assert_equal(x, y):
    if x == y:
        print(".")
    else:
        print("FAIL")

# Insertion
print("Insertion")

# No rotation
t = treap.Treap()
t.insert(10, 1)
t.insert(5, 2)
t.insert(15, 3)
assert_equal(t.root.value, 10)
assert_equal(t.root.left_child.value, 5)
assert_equal(t.root.right_child.value, 15)

# Counterclockwise rotation
t = treap.Treap()
t.insert(10, 2)
t.insert(5, 1)
t.insert(15, 3)
assert_equal(t.root.value, 5)
assert_equal(t.root.right_child.value, 10)
assert_equal(t.root.right_child.right_child.value, 15)

# Clockwise rotation
t = treap.Treap()
t.insert(10, 2)
t.insert(5, 3)
t.insert(15, 1)
assert_equal(t.root.value, 15)
assert_equal(t.root.left_child.value, 10)
assert_equal(t.root.left_child.left_child.value, 5)

# Multiple rotations
t = treap.Treap()
t.insert("m", 50)
t.insert("c", 75)
t.insert("x", 80)
t.insert("a", 85)
t.insert("e", 86)
t.insert("p", 87)
t.insert("z", 90)
t.insert("g", 1)
assert_equal(t.root.value, "g")
assert_equal(t.root.parent, None)
assert_equal(t.root.left_child.value, "c")
assert_equal(t.root.left_child.left_child.value, "a")
assert_equal(t.root.left_child.right_child.value, "e")
assert_equal(t.root.right_child.value, "m")
assert_equal(t.root.right_child.right_child.value, "x")

# Search
print("Search")
assert_equal(t.search("z").value, "z")
assert_equal(t.search("b"), None)

# Deletion
print("Deletion")
t.delete("g")
assert_equal(t.root.value, "m")
assert_equal(t.root.left_child.value, "c")
assert_equal(t.root.left_child.left_child.value, "a")
assert_equal(t.root.left_child.right_child.value, "e")
assert_equal(t.root.right_child.value, "x")

# Visualize tree levels of randomized treap
# This isn't an official test, but feel free to uncomment to play around
# print("Visualize tree levels of randomized treap")

# for j in range(5):
#     t = treap.Treap()
#     for i in range(500):
#         t.insert(i)

#     tree_levels = t.tree_levels(t.root, [])
#     # print(tree_levels)

#     print(len(tree_levels))
