import division_hasher


class HashTable:

    def __init__(self, array_length):
        self.array_length = array_length
        self.array = [[]] * self.array_length
        self.hasher = division_hasher.DivisionHasher(self.array_length)
    
    def insert(self, key, value):
        hashcode = self.hasher.hash(key)

        for key_value_pair in self.array[hashcode]:
            if key_value_pair[0] == key:
                key_value_pair[1] = value
                return

        self.array[hashcode].append([key, value])

    def search(self, key):
        hashcode = self.hasher.hash(key)

        for key_value_pair in self.array[hashcode]:
            if key_value_pair[0] == key:
                return key_value_pair[1]
 
        return None
    
    def delete(self, key):
        hashcode = self.hasher.hash(key)

        for index, key_value_pair in enumerate(self.array[hashcode]):
            if key_value_pair[0] == key:
                del self.array[hashcode][index]
