# Global base variable:
base = 26


def find_needle(haystack, needle):
    needle_hash_code = initial_hash(needle)
    window_hash_code = initial_hash(haystack[0:(len(needle))])

    if needle_hash_code == window_hash_code:
        return 0

    for index in range(1, len(haystack) - len(needle) + 1):
        drop_character = haystack[index - 1]
        new_character = haystack[index - 1 + len(needle)]
        window_hash_code = rolling_hash(window_hash_code, len(needle), drop_character, new_character)

        if needle_hash_code == window_hash_code:
            return index

    return None


def initial_hash(string):
    power = 0
    result = 0

    for char in reversed(string):
        result += character_hash_code(char) * base**power
        power += 1

    return result


def rolling_hash(hash_code, window_length, drop_character, new_character):
    drop_number = character_hash_code(drop_character) * base**(window_length - 1)
    result = hash_code - drop_number
    result *= base
    result += character_hash_code(new_character)

    return result


def character_hash_code(char):
    return ord(char) - 97
