import brute_force_substring_search
import rabin_karp_1
import rabin_karp_2
import rabin_karp_3


def assert_equal(x, y):
    if x == y:
        print(".")
    else:
        print("FAIL")


# Brute Force Substring Search
print("Brute Force Substring Search")
assert_equal(brute_force_substring_search.find_needle('flibbertigib', 'be'), 4)
assert_equal(brute_force_substring_search.find_needle('flibbertigibbet', 'bet'), 12)
assert_equal(brute_force_substring_search.find_needle('flibbertigibbet', 'fla'), None)

# Rabin-Karp Version #1
print("Rabin-Karp Version #1")
assert_equal(rabin_karp_1.find_needle('flibbertigib', 'be'), 4)
assert_equal(rabin_karp_1.find_needle('flibbertigib', 'fli'), 0)
assert_equal(rabin_karp_1.find_needle('flibbertigibbet', 'bet'), 12)
assert_equal(rabin_karp_1.find_needle('flibbertigibbet', 'fla'), None)

# Rabin-Karp Version #2
print("Rabin-Karp Version #2")
assert_equal(rabin_karp_2.find_needle('heyhowsitgoingsweet', 'go'), 9)
assert_equal(rabin_karp_2.find_needle('heyhowsitgoingsweet', 'hey'), 0)
assert_equal(rabin_karp_2.find_needle('heyhowsitgoingsweet', 'eet'), 16)
assert_equal(rabin_karp_2.find_needle('heyhowsitgoingsweet', 'fla'), None)
assert_equal(rabin_karp_2.find_needle('lklklklklklk', 'ma'), None)

# Rabin-Karp Version #3
print("Rabin-Karp Version #3")
assert_equal(rabin_karp_3.find_needle('heyhowsitgoingsweet', 'go'), 9)
assert_equal(rabin_karp_3.find_needle('heyhowsitgoingsweet', 'hey'), 0)
assert_equal(rabin_karp_3.find_needle('heyhowsitgoingsweet', 'eet'), 16)
assert_equal(rabin_karp_3.find_needle('heyhowsitgoingsweet', 'fla'), None)
assert_equal(rabin_karp_3.find_needle('lklklklklklk', 'ma'), None)
