# A bit array demo - written for Python 3.0
# import array
# Notes:
# 4294967295 is equal to a 32 bit integer with all bits set to 1
import math


def makeBitArray(bitSize, fill=0):
    # intSize = bitSize >> 5                   # number of 32 bit integers
    intSize = bitSize / 32

    if (bitSize & 31):                       # if bitSize != (32 * n) add
        intSize += 1                         # a record for stragglers
    # if fill == 1:
    #     fill = 12  # this is what each value of array is. 4294967295 - all bits set
    # else:
    #     fill = 0                                      # all bits cleared
    fill = 0

    bitArray = []

    bitArray.extend((fill,) * intSize)

    return bitArray


# testBit() returns a nonzero result, 2**offset, if the bit at 'bit_num' is set to 1. Otherwise it returns 0.
def testBit(array_name, bit_num):
    record = bit_num >> 5
    offset = bit_num & 31       # equivalent to bit_num % 32
    mask = 1 << offset
    return array_name[record] & mask


# setBit() sets to 1.
def setBit(array_name, bit_num):
    record = bit_num >> 5
    offset = bit_num & 31
    mask = 1 << offset
    array_name[record] |= mask
    return array_name[record]


# clearBit() sets to 0.
def clearBit(array_name, bit_num):
    record = bit_num >> 5
    offset = bit_num & 31
    mask = ~(1 << offset)
    array_name[record] &= mask
    return array_name[record]


# toggleBit() returns an integer with the bit at 'bit_num' inverted, 0 -> 1 and 1 -> 0.
def toggleBit(array_name, bit_num):
    record = bit_num >> 5
    offset = bit_num & 31
    mask = 1 << offset
    array_name[record] ^= mask
    return array_name[record]


# def one_bits(array_name):
#     i = 0
#     for n in array_name:
#         while n:
#             i += 1
#             b = n & (~n+1)
#             yield math.log2(b)
#             n ^= b


# * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
bits = 96                    # change these numbers to

ini = 1                         # test the function

myArray = makeBitArray(bits, ini)

# array info: input bits; final length; excess bits; fill pattern
# print(bits, len(myArray), (len(myArray) * 32) - bits, bin(myArray[0]))
# setBit(myArray, 12)
# setBit(myArray, 8)
# setBit(myArray, 31)
# setBit(myArray, 63)
# setBit(myArray, 12)
# setBit(myArray, 95)
# setBit(myArray, 44)
# setBit(myArray, 30)
# setBit(myArray, 51)
# setBit(myArray, 9)
# setBit(myArray, 17)
# setBit(myArray, 88)
# setBit(myArray, 74)
# setBit(myArray, 48)
# setBit(myArray, 33)
# setBit(myArray, 25)
# setBit(myArray, 80)
# setBit(myArray, 66)
setBit(myArray, 4)
setBit(myArray, 5)
setBit(myArray, 32)
setBit(myArray, 33)
setBit(myArray, 66)
setBit(myArray, 67)
print(myArray)

# for bit in one_bits(myArray):
#     print(bit)
# x = []
# for i in range(0, 95):
#     if testBit(myArray, i) > 0:
#         x.append(i)
# print(x)

# print(testBit(myArray, 33))
