import find_duplicates
import counting_sort
import find_duplicates_boolean
import counting_sort_boolean
import find_duplicates_bit_vector
import counting_sort_bit_vector
import add_binary
import bit_vector


def assert_equal(x, y):
    if x == y:
        print(".")
    else:
        print("FAIL")


# Find Duplicates
print("Find Duplicates Hash Table")
assert_equal(find_duplicates.find_duplicates([4, 3, 5, 1, 7, 2, 6, 8]), False)
assert_equal(find_duplicates.find_duplicates([4, 3, 5, 1, 7, 2, 6, 1]), True)

# Counting Sort
print("Counting Sort Hash Table")
assert_equal(counting_sort.counting_sort([1000, 235, 9, 1, 666]),
             [1, 9, 235, 666, 1000])

# Find Duplicates Boolean
print("Find Duplicates Boolean")
assert_equal(find_duplicates_boolean.find_duplicates([4, 3, 5, 1, 7, 2, 6, 8]), False)
assert_equal(find_duplicates_boolean.find_duplicates([4, 3, 5, 1, 7, 2, 6, 1]), True)

# Counting Sort Boolean
print("Counting Sort Boolean")
assert_equal(counting_sort_boolean.counting_sort([1000, 235, 9, 1, 666]),
             [1, 9, 235, 666, 1000])

# Find Duplicates Bit Vector
print("Find Duplicates Bit Vector")
assert_equal(find_duplicates_bit_vector.find_duplicates([4, 3, 5, 1, 7, 2, 6, 8]), False)
assert_equal(find_duplicates_bit_vector.find_duplicates([4, 3, 5, 1, 7, 2, 6, 1]), True)

# Counting Sort Bit Vector
print("Counting Sort Bit Vector")
assert_equal(counting_sort_bit_vector.counting_sort([1000, 235, 9, 1, 666]),
             [1, 9, 235, 666, 1000])

# Add Binary Numbers
print("Add Binary Numbers")
assert_equal(add_binary.add(13, 20), 33)
assert_equal(add_binary.add(0, 1), 1)
assert_equal(add_binary.add(1, 0), 1)

# Bit Vector
# Set and Get
print("Bit Vector - Set and Get Bits")
bv = bit_vector.BitVector(1024)
bv.set_bit(1002)
assert_equal(bv.read_bit(1002), True)
assert_equal(bv.read_bit(0), False)
assert_equal(bv.read_bit(1023), False)

# Clear Bit
print("Bit Vector - Clear Bit")
bv.clear_bit(1002)
assert_equal(bv.read_bit(1002), False)

# Toggle Bit
print("Bit Vector - Toggle Bit")
bv.toggle_bit(1002)
assert_equal(bv.read_bit(1002), True)
bv.toggle_bit(1002)
assert_equal(bv.read_bit(1002), False)

# Values
print("Values")
bv = bit_vector.BitVector(1024)
bv.set_bit(20)
bv.set_bit(31)
bv.set_bit(100)
bv.set_bit(191)
bv.set_bit(312)
bv.set_bit(613)
bv.set_bit(1002)
assert_equal(bv.values(), [20, 31, 100, 191, 312, 613, 1002])
