class BitVector:
    def __init__(self, range_of_bits):
        integers_length = range_of_bits // 32
        if range_of_bits % 32 != 0:
            integers_length += 1
        self.integers = [0] * integers_length

    def read_bit(self, index):
        integer_index = index // 32
        bit_index = index % 32
        mask = 1 << bit_index
        return (mask & self.integers[integer_index]) != 0

    def set_bit(self, index):
        integer_index = index // 32
        bit_index = index % 32
        mask = 1 << bit_index
        self.integers[integer_index] |= mask

    def clear_bit(self, index):
        integer_index = index // 32
        bit_index = index % 32
        mask = ~(1 << bit_index)
        self.integers[integer_index] &= mask

    def toggle_bit(self, index):
        integer_index = index // 32
        bit_index = index % 32
        mask = 1 << bit_index
        self.integers[integer_index] ^= mask

    def values(self):
        set = []
        offset = 0
        for integer in self.integers:
            int = integer
            for index in range(32):
                if int & 1 != 0:
                    set.append(offset + index)
                int >>= 1

            offset += 32

        return set
