import bloom_filter
import alt_bloom_filter
import sys
import find_duplicates_bloom_filter


def assert_equal(x, y):
    if x == y:
        print(".")
    else:
        print("FAIL")


# Bloom Filter
print("Bloom filter - classic constructor")
bf = bloom_filter.BloomFilter(100, 0.05)
assert_equal(bf.m, 623)
assert_equal(bf.k, 4)

bf.insert('apple')
bf.insert('carrot')
assert_equal(bf.read('apple'), True)
assert_equal(bf.read('carrot'), True)
assert_equal(bf.read('banana'), False)
assert_equal(bf.read('doughnut'), False)

# print(bf.bv.integers)
# print(bf.bv.values())

print("Bloom filter - alternative constructor")
bf2 = alt_bloom_filter.BloomFilter(100, 623)
assert_equal(bf2.f, 0.05038983314894648)
assert_equal(bf2.k, 4)

bf2.insert('apple')
bf2.insert('carrot')
assert_equal(bf2.read('apple'), True)
assert_equal(bf2.read('carrot'), True)
assert_equal(bf2.read('banana'), False)
assert_equal(bf2.read('doughnut'), False)

# Comparing size of Bloom filter versus hash table for set of size 100
# bf3 = bloom_filter.BloomFilter(100, 0.01)
# print(sys.getsizeof(bf3.bv))
# hash_table = {}
# for i in range(100):
#     hash_table[i] = True
# print(sys.getsizeof(hash_table))

# Find duplicates with Bloom filter
print("Find duplicates with Bloom filter")
array1 = []
for i in range(100):
    array1.append(i)
    array1.append(88)
assert_equal(find_duplicates_bloom_filter.find_duplicates(array1), True)
array2 = []
for i in range(100):
    array2.append(i)
assert_equal(find_duplicates_bloom_filter.find_duplicates(array2), False)
